Package org.italiangrid.voms.ac

# Interface VOMSACValidator

All Superinterfaces:
  `VOMSACParser`

All Known Implementing Classes:
  `DefaultVOMSValidator`

public interface VOMSACValidator extends VOMSACParser
This interface extends the `VOMSACParser` interface and provides methods to perform validation on the VOMS Attribute Certificates parsed from a given certificate chain.

Author:
  Andrea Ceccanti

## Method Summary

Modifier and Type
Method
Description
`void`
`setValidationResultListener(ValidationResultListener listener)`
Sets a listener that will received validation-related events for this `VOMSACValidator`.
`void`
`shutdown()`
Shutdown the VOMS validator.
`List<VOMSAttribute>`
`validate(X509Certificate[] validatedChain)`
Parses and validates the VOMS attributes found in the certificate chain passed as argument (which is assumed to be validated already).
`List<org.bouncycastle.asn1.x509.AttributeCertificate>`
`validateACs(List<org.bouncycastle.asn1.x509.AttributeCertificate> acs)`
Validates the VOMS attributes found in the attribute certificate list passed as argument.
`List<VOMSValidationResult>`
`validateWithResult(X509Certificate[] validatedChain)`
Parses and validates the VOMS attributes found in the certificate chain passed as argument (which is assumed to be validated already).

### Methods inherited from interface org.italiangrid.voms.ac.VOMSACParser

`parse`

## Method Details

### validate

List<VOMSAttribute> validate(X509Certificate[] validatedChain)
Parses and validates the VOMS attributes found in the certificate chain passed as argument (which is assumed to be validated already). This method returns the possibly empty list of the validated attributes. This method should be used in conjunction with the registration of a `ValidationResultListener` to get details about validation error and warning messages. Use the `validateWithResult(X509Certificate[])` method in case you don't want to rely on a `ValidationResultListener`.

Parameters:
  `validatedChain` - a validated X.509 certificate chain
Returns:
  a possibly empty list of `VOMSAttribute` object providing access to the validated VOMS attributes

### validateWithResult

List<VOMSValidationResult> validateWithResult(X509Certificate[] validatedChain)
Parses and validates the VOMS attributes found in the certificate chain passed as argument (which is assumed to be validated already). This method returns a possibly empty list of `VOMSValidationResult` objects which describe the outcome of the validation for each VOMS AC found in the certificate chain. This method is useful when you want to use a single call to get all details about validation without relying on the registration of a `ValidationResultListener`.

Parameters:
  `validatedChain` - a chain of X.509 certificates
Returns:
  a possibly empty list of `VOMSValidationResult` object providing access to validation results and related attributes

### validateACs

List<org.bouncycastle.asn1.x509.AttributeCertificate> validateACs(List<org.bouncycastle.asn1.x509.AttributeCertificate> acs)
Validates the VOMS attributes found in the attribute certificate list passed as argument.

Parameters:
  `acs` - a list of `AttributeCertificate`
Returns:
  the validated and possibly empty list of `AttributeCertificate` object

### setValidationResultListener

void setValidationResultListener(ValidationResultListener listener)
Sets a listener that will received validation-related events for this `VOMSACValidator`.

Parameters:
  `listener` - the listener that will receive validation-related events.

### shutdown

void shutdown()
Shutdown the VOMS validator. This method should be called to perform final cleanup operations.